import java.util.ArrayList;
import java.util.Random;

interface Generator<T> {
	T next();
}

class IntegerGenerator implements Generator<Integer> {
	private final Random rnd;	

	public IntegerGenerator() {
		rnd = new Random();
	}

	public Integer next() {
		return rnd.nextInt();
	}

}

public class Example07 {
	public static void main(String[] args) {
		Generator<?> gen = new IntegerGenerator();
		for (int i = 0; i < 18; i++)
			System.out.print(gen.next() + " ");
	}

}
